# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from carla_msgs/CarlaEgoVehicleStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import carla_msgs.msg
import std_msgs.msg

class CarlaEgoVehicleStatus(genpy.Message):
  _md5sum = "7d24d9cd2c1c81e9a2b845b347cb2162"
  _type = "carla_msgs/CarlaEgoVehicleStatus"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """#
# Copyright (c) 2019 Intel Corporation.
#
# This work is licensed under the terms of the MIT license.
# For a copy, see <https://opensource.org/licenses/MIT>.
#

Header header

float32 velocity
geometry_msgs/Accel acceleration
geometry_msgs/Quaternion orientation

# the current control values, as reported by Carla
CarlaEgoVehicleControl control

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Accel
# This expresses acceleration in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: carla_msgs/CarlaEgoVehicleControl
#
# Copyright (c) 2018-2019 Intel Corporation.
#
# This work is licensed under the terms of the MIT license.
# For a copy, see <https://opensource.org/licenses/MIT>.
#
# This represents a vehicle control message sent to CARLA simulator

Header header

# The CARLA vehicle control data

# 0. <= throttle <= 1.
float32 throttle

# -1. <= steer <= 1.
float32 steer

# 0. <= brake <= 1.
float32 brake

# hand_brake 0 or 1
bool hand_brake

# reverse 0 or 1
bool reverse

# gear
int32 gear

# manual gear shift
bool manual_gear_shift
"""
  __slots__ = ['header','velocity','acceleration','orientation','control']
  _slot_types = ['std_msgs/Header','float32','geometry_msgs/Accel','geometry_msgs/Quaternion','carla_msgs/CarlaEgoVehicleControl']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,velocity,acceleration,orientation,control

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CarlaEgoVehicleStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.velocity is None:
        self.velocity = 0.
      if self.acceleration is None:
        self.acceleration = geometry_msgs.msg.Accel()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.control is None:
        self.control = carla_msgs.msg.CarlaEgoVehicleControl()
    else:
      self.header = std_msgs.msg.Header()
      self.velocity = 0.
      self.acceleration = geometry_msgs.msg.Accel()
      self.orientation = geometry_msgs.msg.Quaternion()
      self.control = carla_msgs.msg.CarlaEgoVehicleControl()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_f10d3I().pack(_x.velocity, _x.acceleration.linear.x, _x.acceleration.linear.y, _x.acceleration.linear.z, _x.acceleration.angular.x, _x.acceleration.angular.y, _x.acceleration.angular.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w, _x.control.header.seq, _x.control.header.stamp.secs, _x.control.header.stamp.nsecs))
      _x = self.control.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3f2BiB().pack(_x.control.throttle, _x.control.steer, _x.control.brake, _x.control.hand_brake, _x.control.reverse, _x.control.gear, _x.control.manual_gear_shift))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.acceleration is None:
        self.acceleration = geometry_msgs.msg.Accel()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.control is None:
        self.control = carla_msgs.msg.CarlaEgoVehicleControl()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 96
      (_x.velocity, _x.acceleration.linear.x, _x.acceleration.linear.y, _x.acceleration.linear.z, _x.acceleration.angular.x, _x.acceleration.angular.y, _x.acceleration.angular.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w, _x.control.header.seq, _x.control.header.stamp.secs, _x.control.header.stamp.nsecs,) = _get_struct_f10d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.control.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.control.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 19
      (_x.control.throttle, _x.control.steer, _x.control.brake, _x.control.hand_brake, _x.control.reverse, _x.control.gear, _x.control.manual_gear_shift,) = _get_struct_3f2BiB().unpack(str[start:end])
      self.control.hand_brake = bool(self.control.hand_brake)
      self.control.reverse = bool(self.control.reverse)
      self.control.manual_gear_shift = bool(self.control.manual_gear_shift)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_f10d3I().pack(_x.velocity, _x.acceleration.linear.x, _x.acceleration.linear.y, _x.acceleration.linear.z, _x.acceleration.angular.x, _x.acceleration.angular.y, _x.acceleration.angular.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w, _x.control.header.seq, _x.control.header.stamp.secs, _x.control.header.stamp.nsecs))
      _x = self.control.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3f2BiB().pack(_x.control.throttle, _x.control.steer, _x.control.brake, _x.control.hand_brake, _x.control.reverse, _x.control.gear, _x.control.manual_gear_shift))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.acceleration is None:
        self.acceleration = geometry_msgs.msg.Accel()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.control is None:
        self.control = carla_msgs.msg.CarlaEgoVehicleControl()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 96
      (_x.velocity, _x.acceleration.linear.x, _x.acceleration.linear.y, _x.acceleration.linear.z, _x.acceleration.angular.x, _x.acceleration.angular.y, _x.acceleration.angular.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w, _x.control.header.seq, _x.control.header.stamp.secs, _x.control.header.stamp.nsecs,) = _get_struct_f10d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.control.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.control.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 19
      (_x.control.throttle, _x.control.steer, _x.control.brake, _x.control.hand_brake, _x.control.reverse, _x.control.gear, _x.control.manual_gear_shift,) = _get_struct_3f2BiB().unpack(str[start:end])
      self.control.hand_brake = bool(self.control.hand_brake)
      self.control.reverse = bool(self.control.reverse)
      self.control.manual_gear_shift = bool(self.control.manual_gear_shift)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3f2BiB = None
def _get_struct_3f2BiB():
    global _struct_3f2BiB
    if _struct_3f2BiB is None:
        _struct_3f2BiB = struct.Struct("<3f2BiB")
    return _struct_3f2BiB
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_f10d3I = None
def _get_struct_f10d3I():
    global _struct_f10d3I
    if _struct_f10d3I is None:
        _struct_f10d3I = struct.Struct("<f10d3I")
    return _struct_f10d3I
